<template>
  <div>
    <!-- Cuerpo -->
    <div class="padding-top">
      <el-header height="110px" style="margin: 0 12rem">
        <ReturnButton v-on:clickEvent="viewListAmort" title="Ir a Amortizaciones" :offsetArrow="19" :spanTitle="4" class="text-end"></ReturnButton>
        <!-- <el-col :span="24" style="padding-top: 1.5rem">
          <el-card :body-style="{ padding: '10px' }" shadow="never" class="bg-gray border-none title-views"> {{schemaName}} </el-card>
        </el-col> -->

        <!-- COMPONENTE TITULO -->
        <div style="padding-top: 1.5rem">
          <Title :Title="schemaName"> </Title>
        </div>
        <!-- Modal botón regresar -->
        <AppModal :show-dialog.sync="showModalEspecif"  v-if="showModalEspecif" nameClass="dialog-red"  :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%"  textBold="¿Estás seguro?" 
          :parrafo="' Si sales del formulario, la información se perderá. '"
          classBtn1="border-red" typeBtn1="danger" btn1="Salir" btn2="Seguir aquí" @btnEvent="viewListAmortization"  v-on:eventBtn="showModalEspecif = false">
        </AppModal>

      </el-header>
      <el-main style="margin:3rem 12rem">
        <h3 class="text-orange" style="margin-bottom:2.5rem">DATOS DEL ESQUEMA DE AMORTIZACIÓN</h3>
        <el-form :rules="rules" ref="form" :model="amortizationSchema">
          <el-form-item style="margin: 1.5rem 0 0" prop="originalTitle">
            <el-row>
              <el-col :span="5">
                <p class="fonts-bold-general">Nombre del Esquema:</p>
              </el-col>
              <el-col :span="7">
                <el-input v-model="amortizationSchema.schemaName" size="small"></el-input>
              </el-col>
            </el-row>
          </el-form-item>
          <el-form-item style="margin: 1.5rem 0 0" prop="">
            <el-row>
              <el-col :span="5">
                <p class="fonts-bold-general" >Tipo de Amortización:</p>
              </el-col>
              <el-col :span="7">
                <el-select v-model="amortizationSchema.amortizationType" placeholder="seleccionar" size="small">
                  <el-option label="Pasadas" value="Pasadas"></el-option>
                  <el-option label="Otros" value="Otros"></el-option>
                </el-select>
              </el-col>
            </el-row>
          </el-form-item>

          <el-form-item style="margin: 1.5rem 0 0" prop="codeAmort">
            <el-row :gutter="20">
              <el-col :span="5">
                <p class="fonts-bold-general"><span style="color: #fc0000; margin-right: 4px;">*</span>Tipo de Proceso:</p>
              </el-col>
              <el-col :span="7">
                <el-select v-model="amortizationSchema.codeAmort" placeholder="Seleccionar" size="small" @change="isExit(amortizationSchema.codeAmort, amortizationSchema.amortizationPercentage)" disabled>
                  <el-option label="Pasadas Tipo 1" value="PAS"></el-option>
                  <el-option label="Pasadas Tipo 2" value="PAS2"></el-option>
                  <el-option label="Pasadas Tipo 3" value="PAS3"></el-option>
                </el-select>
              </el-col>
            </el-row>
          </el-form-item>

          <el-form-item style="margin: 1.5rem 0 0" prop="">
            <el-row :gutter="20">
              <el-col :span="5">
                <p class="fonts-bold-general" ><span style="color: #fc0000; margin-right: 4px;">*</span>Tipo de Contrato:</p>
              </el-col>
              <el-col :span="5">                
                <el-checkbox-group v-model="checkedContractTypes" :min="2" :max="2">
                  <el-checkbox v-for="contract in contracts" :label="contract" :key="contract" style="margin:0 1rem">{{contract}}</el-checkbox>
                </el-checkbox-group>
              </el-col>
            </el-row>
          </el-form-item>
          <hr style="margin-top:2.5rem">
           <el-form-item style="margin: 1.5rem 0 0" prop="">
            <el-row :gutter="20">
              <h3 class="text-orange" style="margin-left:0.5rem">MATERIALES</h3>
              <el-col :span="10">
                <el-checkbox :indeterminate="isIndeterminate2" v-model="checkAllMaterial" @change="handleCheckAllMaterial" style="margin:0 1rem">Seleccionar todos</el-checkbox>
                <el-checkbox-group v-model="amortizationSchema.materialTypes" @change="materialChange" style="column-count: 2; flex-direction: row">
                  <el-checkbox v-for="materialType in allMaterialType" :label="materialType" :key="materialType" style="margin:0 1rem; line-height:1">{{materialType}}</el-checkbox>
                </el-checkbox-group>

                <AppModal :show-dialog.sync="coincidenceModal" widthModal="43%"  v-if="coincidenceModal" nameClass="dialog-orange"  :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80px"
                    :textBold="'¿Quieres priorizar la Amortización de ' + amortizationSchema.schemaName + ' para ' + this.aType + ' ?' " :parrafo="'La amortización ' + this.beforeSchema + ' no se elimanará.'"
                    classBtn1="border-orange" typeBtn1="primary" btn1="CANCELAR" btn2="PRIORIZAR"  v-on:btnEvent="cancelModalPrioritize(coincidenceModal)"   v-on:eventBtn="coincidenceModal = false">
                 </AppModal> 
              </el-col>
            </el-row>
          </el-form-item>
          <hr style="margin-top:2.5rem">
          <el-form-item style="margin: 1.5rem 0 7rem" prop="">
            <el-row :gutter="20">
              <h3 class="text-orange" style="margin-left:0.5rem; margin-bottom:1.5rem">DETALLES DEL ESQUEMA {{schemaName}}</h3>
              <el-row :gutter="10">
                <el-col :span="5">
                  <p class="fonts-bold-general" style="margin-left:0.5rem"><span style="color: #fc0000; margin-right: 4px;">*</span>N° de Amortizaciones:</p>
                </el-col>
                <el-form-item class="ml-12" prop="amortizationPercentage">
                  <el-col :span="2">
                    <el-input v-model="amortizationSchema.amortizationPercentage" size="small" @keyup.enter.native= "addPercentage" v-on:keypress.native="isNumber" @change="isExit(amortizationSchema.codeAmort, amortizationSchema.amortizationPercentage)" disabled></el-input>
                  </el-col>
                </el-form-item>
              </el-row>
              <el-row :gutter="20">
                <p class="fonts-bold-general" style="margin:2rem 13.1rem 0.8rem">Porcentaje de Amortización:</p>
                <el-col v-for="(num, index) in amortizationSchema.arrayOfPercentage" :key="index">
                  <el-col :span="2" :offset="5">
                    <el-input v-model="num.indexPercentage" size="small" :disabled="true"></el-input>
                  </el-col>
                  <el-col :span="4">
                    <el-input v-model="num.amortizationP" size="small" @keyup.enter.native="calculateAmortPercent" v-on:keypress.native="isNumber">
                      <template slot="append">%</template>
                    </el-input>
                  </el-col>
                </el-col>
              </el-row>
              <hr style="width:8.5rem; margin:0.5rem 0 0.4rem 17.9rem">
              <el-col :span="2" style="margin-left:12.3rem">
                <p class="fonts-bold-general"><span style="color: #fc0000; margin-right: 4px;">*</span>Total:</p>
              </el-col>
              <el-form-item style="margin-left: 13rem" prop="totalAmort">
                <el-col :span="5">
                  <el-input v-model="amortizationSchema.totalAmort" size="small" disabled>
                    <template slot="append">%</template>
                  </el-input>
                </el-col>
              </el-form-item>
            </el-row>
          </el-form-item>
          <el-row type="flex" justify="end">
            <el-button @click="modalCancelButton = true" class="text-orange border-orange">CANCELAR</el-button>
            <el-button type="primary" @click="submitAmort('amortizationSchema')">ACTUALIZAR</el-button>
          </el-row> 
          <!-- Modal botón cancelar -->
          <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton"  v-on:btnEvent="viewListAmortization"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
          </AppModalDanger>

          <!-- Modal validación-->
          <el-dialog :visible.sync="modalAmortHigherPercent"
          width="33%"
          center
          :close-on-press-escape="false"
          :show-close="false"
          custom-class="dialog-red"> 
            <el-row >
              <el-col :span="5" class="text-center"><img src="@/assets/images/alerta.svg"  alt="emoticon" width="80%"></el-col>
              <el-col :span="18" :offset="1">
                <p> El total de los porcentajes de amortización, <br> <span class="text-red text-bold"> SUPERA </span> el 100%  </p>
              </el-col>
            </el-row>
          </el-dialog>

          <el-dialog :visible.sync="modalAmortLessPercent"
          width="33%"
          center
          :close-on-press-escape="false"
          :show-close="false"
          custom-class="dialog-red"> 
            <el-row >
              <el-col :span="5" class="text-center"><img src="@/assets/images/alerta.svg"  alt="emoticon" width="80%"></el-col>
              <el-col :span="18" :offset="1">
                <p> El total de los porcentajes de amortización, <br> <span class="text-red text-bold"> ES MENOR </span> a 100%  </p>
              </el-col>
            </el-row>
          </el-dialog>

          <el-dialog :visible.sync="modalAmortCorrectPercent"
          width="33%"
          center
          :close-on-press-escape="false"
          :show-close="false"
          custom-class="dialog-green"> 
            <el-row >
              <el-col :span="5" class="text-center"><img src="@/assets/images/check-verde.svg"  alt="emoticon" width="80%"></el-col>
              <el-col :span="18" :offset="1">
                <p> El total de los porcentajes de amortización, <br> es <strong>100%</strong></p>
              </el-col>
            </el-row>
          </el-dialog>

          <!-- Modal formulario invalido -->
          <el-dialog
            :visible.sync="invalidForm"
            width="33%"
            center
            :show-close="false"
            custom-class="dialog-red">
            <el-row>
              <el-col :span="5"><img src="@/assets/images/alerta.svg" width="80%" alt="emoticon"></el-col>
              <el-col :span="18" :offset="1">
                <div style="line-height: 22px;" v-html="textModalInvalid"></div>
              </el-col>
            </el-row>
          </el-dialog>
        </el-form> 
      </el-main>
    </div>
  </div>
</template>
<script>

import ReturnButton from '@/components/ReturnButton.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import AppModal from '@/components/AppModal.vue'
import {HTTP} from '@/main.js'
import Title from '@/components/Title.vue'  


const contractOptions = ['Extranjero', 'Local']
const allMaterialTypeOptions = ['Dibujos','Series','Largometrajes','Novelas', 'Miniseries','Programas Especiales']

export default {
  components: {
    ReturnButton,
    AppModalDanger,
    AppModal,
    Title
  },
  data() {
    return {
      modalAmortHigherPercent: false ,
      modalAmortLessPercent: false,
      modalAmortCorrectPercent: false,
      // getAmort:JSON.parse(this.$localStorage.get('objSelected')),
      editAmortArray:[],
      amortizationP:'',
      indexPercentage:'',
      form: {
        contractType:[],
        materialTypes:[],
      },
      checkAll: false,
      contracts: contractOptions,
      isIndeterminate: true,
      checkAllMaterial:false,
      allMaterialType:allMaterialTypeOptions,
      isIndeterminate2: true,
      onlyPercentage:[],
      description:[],
      modalCancelButton: false,
      mainDescription:[],
      checkedMaterialTypes: [],
      coincidenceModal: false,
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      amortizationSchema: {},
      getSchemas: JSON.parse(this.$localStorage.get('tableAmort')),
      amortId: '',
      codePass: '',
      valueMaterial: '',
      checkedContractTypes: ['Extranjero', 'Local'],
      descriptionOracle: [],
      // datosOriginalesOracle: JSON.parse(this.$localStorage.get('datosOriginalesOracle')),
      prevAmortizationSchema: {},
      showModal: false,
      showModalEspecif: false,
      rules: {
        codeAmort: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        totalAmort: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        amortizationPercentage: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
      },
      invalidForm: false,
      textModalInvalid: '<p>Por favor, ingrese todos los campos requeridos.</p>',
      isAcceptCreated: true
    };
  },
  created() {
    this.gettingUsername()
    this.fetchSegment()
  },
  methods: {
    async isExit(type, currence) {
      console.log('isExit')
      let schemaOriginal = this.prevAmortizationSchema
      if(type && type !== '' && currence && currence !== '' && currence !== '0') {
        // prevAmortizationSchema
        let {data} = await HTTP.post(`amortization/filterSchema`, {
          numOcurrencia: currence,
          tprCodigo: type
        })
        let valueExist = data.exist
        // console.log({amortizationPercentage: schemaOriginal.amortizationPercentage, currence, codeAmort: schemaOriginal.codeAmort, type})
        if(Number(schemaOriginal.amortizationPercentage) == Number(currence) && type == schemaOriginal.codeAmort) {
          this.isAcceptCreated = true
        } else {
          if(valueExist) {
            this.textModalInvalid = '<p>No se puede crear este <strong>Esquema de Amortización</strong> porque ya existe otro Esquema con el mismo número de amortización y tipo de proceso<p>'
            this.invalidForm = true
            this.isAcceptCreated = false
          } else {
            this.isAcceptCreated = true
          }
        }
        
        // console.log({data, valueExist}, 'isExit')
      }
    },
    gettingUsername(){
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
    cancelModalPrioritize (coincidenceModal) {
      if (this.amortizationSchema.materialTypes.includes(this.valueMaterial.pop())) {
        let index = this.amortizationSchema.materialTypes.findIndex(checkedMaterialType => checkedMaterialType === this.valueMaterial.pop())
        this.amortizationSchema.materialTypes[index] = ''
      }
      this.coincidenceModal = false   
    },
    async patchAmortization () {
      // console.log(this.amortizationSchema.rowNum, 'this.amortizationSchema')

      if(this.amortizationSchema.materialTypes.includes("No ingresado")) {
        let indice = this.amortizationSchema.materialTypes.indexOf("No ingresado");
        this.amortizationSchema.materialTypes.splice(indice, 1);
      }
  
      let other = this.amortizationSchema.materialTypes.length == 0 ? "No ingresado" : this.amortizationSchema.materialTypes

      /*Verificando si cambio la informacion que va a oracle */
      let schemaOriginal = this.prevAmortizationSchema
      let orginalContractType = JSON.stringify(schemaOriginal.contractType)
      let actualContractType = JSON.stringify(this.amortizationSchema.contractType)
      let orginalArrayOfPercentage = JSON.stringify(schemaOriginal.arrayOfPercentage)
      let actualArrayOfPercentage = JSON.stringify(this.amortizationSchema.arrayOfPercentage)
      if(orginalContractType == actualContractType && orginalArrayOfPercentage == actualArrayOfPercentage) {
        
        let response = await HTTP.patch('amortization/patchOnlyMongo/' + this.amortId, [
          { propName: "schemaName", value: this.amortizationSchema.schemaName},
          { propName: "materialTypes", value: other },
          { propName: "userEmail", value: this.userEmail}, 
          { propName: "datsOriginals", value: JSON.parse(this.$localStorage.get("datosOriginalesOracle")) },
          { propName: "rowNum", value: this.amortizationSchema.rowNum },
        ])
        console.log({response})
        if(response.data && response.status == 200) {
          this.$router.push({name: 'amortization'});
        }else {
          console.log('Ocurrio un error y no se pudo actualizar')
        }
      } else {
        HTTP.patch('amortization/' + this.amortId,
        [
          { propName: "schemaName", value: this.amortizationSchema.schemaName},
          { propName: "totalAmort", value: this.amortizationSchema.totalAmort}, 
          { propName: "amortizationType", value: this.amortizationSchema.amortizationType}, 
          { propName: "contractType", value: this.checkedContractTypes}, 
          { propName: "materialTypes", value: other }, 
          { propName: "amortizationPercentage", value: Number(this.amortizationSchema.amortizationPercentage)}, 
          { propName: "arrayOfPercentage", value: this.amortizationSchema.arrayOfPercentage}, 
          { propName: "description", value: this.mainDescription}, 
          { propName: "userName", value: this.userName}, 
          { propName: "userEmail", value: this.userEmail}, 
          { propName: "datsOriginals", value: JSON.parse(this.$localStorage.get("datosOriginalesOracle")) }, 
          { propName: "codeAmort", value: this.amortizationSchema.codeAmort}, 
          { propName: "descriptionOracle", value: this.descriptionOracle},
          { propName: "rowNum", value: this.amortizationSchema.rowNum },
          { propName: "codeAmortPrev", value: this.prevAmortizationSchema.codeAmort },  
          { propName: "amortizationPercentagePrev", value: this.prevAmortizationSchema.amortizationPercentage },  
        ]
      )
      .then(res => {
        this.$router.push({name: 'amortization'});
      })
      .catch(err => console.log(err))
      }
    },
    fetchSegment () {
      const amortizationId = JSON.parse(this.$localStorage.get('amortizationId'))
      // this.axios.get('http://localhost:3009/amortization/' + amortizationId)
      HTTP.get('amortization/' + amortizationId)
        .then(res => {
          console.log({res})
          this.checkedContractTypes = res.data.amortization.contractType
          this.amortizationSchema = res.data.amortization;
          this.prevAmortizationSchema = JSON.parse(JSON.stringify(res.data.amortization))
          this.amortId = this.amortizationSchema._id
          this.editAmortArray = res.data.amortization.arrayOfPercentage

         let datosOriginalesOracle = {
            amortizationPercentage: res.data.amortization.amortizationPercentage,
            codeAmort: res.data.amortization.codeAmort,
            contractType: res.data.amortization.contractType
          }
          this.$localStorage.set("datosOriginalesOracle", JSON.stringify(datosOriginalesOracle))
        })
        .catch(err => console.log(err))
    },
    handleCheckAllMaterial(val) {
      this.amortizationSchema.materialTypes= val ? allMaterialTypeOptions : [];
      this.isIndeterminate2 = false;
    },
    contractsChange(value) {
      let checkedCount = value.length;
      this.checkAll = checkedCount === this.contracts.length;
      this.isIndeterminate = checkedCount > 0 && checkedCount < this.contracts.length;
    },
    materialChange(value) {
      this.valueMaterial = value;
      console.log(value, 'value')
      let checkedCount = value.length;
      this.checkAllMaterial = checkedCount === this.allMaterialType.length;
      this.isIndeterminate2 = checkedCount > 0 && checkedCount < this.allMaterialType.length;
      
      let arrTypes= this.getSchemas
      let arrMatTypes, repSchema
      
      // seleccionando checkbox
      for (let i=0; i<value.length;i++) {
        this.aType = value[i]
        // obtención del nombre y los tipos de materiales
        for (let j=0; j< arrTypes.length ; j++){
          arrMatTypes= arrTypes[j].materialTypes
          repSchema= arrTypes[j].schemaName
          for (let m=0; m< arrMatTypes.length; m++){
            if(this.aType=== arrMatTypes[m]){
              this.coincidenceModal = true
              this.beforeSchema= repSchema
            }
          }
        }
      }
    },
    addPercentage(){
      this.amortizationSchema.totalAmort = 0
      let array = this.amortizationSchema.arrayOfPercentage.length
      let numAmortPercentage
      if (this.amortizationSchema.amortizationPercentage) {
        numAmortPercentage = Number(this.amortizationSchema.amortizationPercentage)
        this.editAmortArray= this.amortizationSchema.arrayOfPercentage
        if(Number(this.amortizationSchema.amortizationPercentage) == 0) {
          for (let i = 0; i < numAmortPercentage; i++) {
            this.editAmortArray[i]={'indexPercentage': i+1, 'amortizationP': ''}
          }
        } else {
          if( array < numAmortPercentage ) {
            for (let i = array; i < numAmortPercentage; i++) {
              let contentPosition = {'indexPercentage': i+1, 'amortizationP': ''}
              this.editAmortArray.push(contentPosition) 
            }
          } else {
            for (let i = numAmortPercentage; i < array; i++) {
              this.editAmortArray.splice(i,(array - numAmortPercentage)) 
            }
          }
        }
      }
    },
    showModalAmortization (total) {
      if(total < 100) {
        this.modalAmortLessPercent = true
      }
      else if (total == 100) {
        this.modalAmortCorrectPercent = true
      }
      else {
        this.modalAmortHigherPercent = true
      }
    },
    calculateAmortPercent () {
      let total = 0
        for (var i = 0; i < this.amortizationSchema.arrayOfPercentage.length; i++) {
          total += Number(this.amortizationSchema.arrayOfPercentage[i].amortizationP)
          if(i == (this.amortizationSchema.arrayOfPercentage.length -1 ) &&  Number(this.amortizationSchema.arrayOfPercentage[i].amortizationP) !== 0) {
          this.showModalAmortization(total)
          }
        }
        this.amortizationSchema.totalAmort= total;
    },
    addDescriptionAmortization() {
      let filter = this.amortizationSchema.arrayOfPercentage.map(e => e.amortizationP)
      let array = []
      let arrayOracle = []

      filter.sort();

      let current = null;
      let cnt = 0;
      for (let i = 0; i < filter.length; i++) {
          if (filter[i] != current) {
              if (cnt > 0) {
                array.push(`${cnt} Pasadas de ${current}%`)
                arrayOracle.push(`${cnt} PAS. ${current}%`)
              }
              current = filter[i];
              cnt = 1;
          } else {
              cnt++;
          }
      }
      if (cnt > 0) {
        array.push(`${cnt} Pasada de ${current}%`)
        arrayOracle.push(`${cnt} PAS. ${current}%`)
      }
      this.description = array
      this.descriptionOracle = arrayOracle
      this.onlyPercentage = filter
    },
    isNumber (evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }
    },
    conditionalDescription(){
      if(this.description.length === 0){
        this.mainDescription= this.amortizationSchema.description
      }else {
        this.mainDescription= this.description
      }
    },
    submitAmort(formName){
      // console.log({amortizationSchema: this.amortizationSchema, formName})
      let dataIncomplete = this.editAmortArray.filter((e) => e.amortizationP == '0' || e.amortizationP == '')
      this.$refs['form'].validate((valid) => {
        if(this.isAcceptCreated && valid && dataIncomplete.length == 0 && Number(this.amortizationSchema.totalAmort) == 100) {
          this.addDescriptionAmortization()
          this.conditionalDescription()
          this.patchAmortization()
          // this.getEsquemas()
        } else {
          if(this.isAcceptCreated == false) {
            this.textModalInvalid = '<p>No se puede crear este <strong>Esquema de Amortización</strong> porque ya existe otro Esquema con el mismo número de amortización y tipo de proceso<p>'
          } else {
            if(Number(this.amortizationSchema.totalAmort) !== 100) {
              this.textModalInvalid = '<p>El total de los porcentajes de amortización debe sumar <span class="text-red text-bold">100%</span>, ¡Verifique la información ingresada!<p>'
            } else {
              this.textModalInvalid = '<p>Por favor, ingrese todos los campos requeridos.<p>'
            }
          }
          this.invalidForm = true
          return false
        }
      })
     },
     viewListAmort () {
      if(this.showModal == true) {
        this.showModalEspecif = true
      } else {
        this.viewListAmortization()
      }
    },
    viewListAmortization () {
      this.$router.push({ name: "amortization" });
    }
  },
  computed: {
    schemaName() {
      if(this.amortizationSchema.schemaName) {
        return this.amortizationSchema.schemaName.toUpperCase()
      } else {
        return 'Nombre'.toUpperCase()
      }
    },
    multiplerFilter() {
      if(this.amortizationSchema) {
        const array = [
          this.amortizationSchema.schemaName,
          this.amortizationSchema.amortizationType,
          this.checkedContractTypes,
          this.valueMaterial,
          this.checkAllMaterial,
          this.editAmortArray
        ].join()
        return array
      }
    }
  },
  watch: {
    multiplerFilter(val) {
      let checkAllConditional = this.checkAllMaterial == true ? 6 : this.amortizationSchema.materialTypes.length
      let valueMaterial = this.valueMaterial == '' ? 0 : this.valueMaterial.length
      let prevMaterialTypes =  this.prevAmortizationSchema.materialTypes[0] == 'No ingresado' ? 0 : this.prevAmortizationSchema.materialTypes.length
      if(
        this.amortizationSchema.schemaName == this.prevAmortizationSchema.schemaName &&
        this.amortizationSchema.amortizationType == this.prevAmortizationSchema.amortizationType &&
        this.checkedContractTypes.length == this.prevAmortizationSchema.contractType.length &&
        checkAllConditional == this.prevAmortizationSchema.materialTypes.length &&
        valueMaterial == prevMaterialTypes
      ) {
        this.showModal = false
      } else {
        this.showModal = true
      }
    },
    editAmortArray: {
      handler: function (val, oldVal) {
      	let arrayPrev = this.prevAmortizationSchema.arrayOfPercentage.map((e) => e.amortizationP)
          let array = this.editAmortArray.map((e) => e.amortizationP)
          let conditional = Boolean(array.filter(e => arrayPrev.indexOf(e) == -1).length)
          this.showModal = conditional
      },
      deep: true
    }
  }
};
</script>